# (c) Copyright Logical Progression Ltd 2002
# Released under the GNU Public License
# Contact andrew@logicalprogression.net for bug reports
# $Id: SendmailHost.py,v 1.1.1.2 2002/11/26 16:41:56 andrew Exp $

from Products.MailHost.MailHost import MailHost
from email.Utils import parseaddr
from Globals import DTMLFile
import os, string

manage_addSendmailHostForm=DTMLFile("dtml/manage_addSendmailHostForm",globals())

def manage_addSendmailHost(self, id, title, REQUEST):
    "Add a SendmailHost to the system"
    i = SendmailHost(id, title)
    self._setObject(id, i)
    if REQUEST:
        return self.manage_main(self, REQUEST)

class SendmailHost(MailHost):
    "A version of the MailHost object which uses sendmail rather than smtplib"

    meta_type='Sendmail Host'

    def _send(self, mfrom, mto, messageText):
        "Send the message"
        mfrom = parseaddr(mfrom)[1] # sendmail needs email address parsed
        toline = ''
        for m in mto:
          toline += parseaddr(m)[1]
        sendmail=os.popen("/usr/sbin/sendmail -f " + mfrom + " " + toline, "w")
        print >>sendmail, messageText
        sendmail.flush()
